commit a49452d964e3bbd1d9aa0d809355f41347b3ec05
Author: liuhongt <hongtao.liu@intel.com>
Date:   Wed Aug 12 10:48:17 2020 +0800

    Don't use pinsr/pextr for struct initialization/extraction.
    
    gcc/
            PR target/96562
            PR target/93897
            * config/i386/i386-expand.c (ix86_expand_pinsr): Don't use
            pinsr for TImode.
            (ix86_expand_pextr): Don't use pextr for TImode.
    
    gcc/testsuite/
            * gcc.target/i386/pr96562-1.c: New test.

diff --git a/gcc/config/i386/i386-expand.c b/gcc/config/i386/i386-expand.c
index 07cd4ddbe36..f7756ddef0f 100644
--- a/gcc/config/i386/i386-expand.c
+++ b/gcc/config/i386/i386-expand.c
@@ -20047,7 +20047,6 @@ ix86_expand_pextr (rtx *operands)
     case E_V4SImode:
     case E_V2DImode:
     case E_V1TImode:
-    case E_TImode:
       {
 	machine_mode srcmode, dstmode;
 	rtx d, pat;
@@ -20143,7 +20142,6 @@ ix86_expand_pinsr (rtx *operands)
     case E_V4SImode:
     case E_V2DImode:
     case E_V1TImode:
-    case E_TImode:
       {
 	machine_mode srcmode, dstmode;
 	rtx (*pinsr)(rtx, rtx, rtx, rtx);
diff --git a/gcc/testsuite/gcc.target/i386/pr96562-1.c b/gcc/testsuite/gcc.target/i386/pr96562-1.c
new file mode 100644
index 00000000000..6ebeeb1fb17
--- /dev/null
+++ b/gcc/testsuite/gcc.target/i386/pr96562-1.c
@@ -0,0 +1,81 @@
+/* { dg-do compile} */
+/* { dg-options "-msse4.1 -O2" } */
+/* { dg-final { scan-assembler-not "pinsr" } } */
+
+typedef struct
+{
+  long long a;
+  int b;
+} st1;
+
+typedef struct
+{
+  long long a;
+  int b;
+  short c;
+} st2;
+
+typedef struct
+{
+  long long a;
+  int b;
+  short c;
+  char d;
+} st3;
+
+typedef struct
+{
+  int b;
+  long long a;
+} st4;
+
+typedef struct
+{
+  short c;
+  int b;
+  long long a;
+} st5;
+
+typedef struct
+{
+  char d;
+  short c;
+  int b;
+  long long a;
+} st6;
+
+st1
+foo1 (long long a, int b)
+{
+  return (st1){a, b};
+}
+
+st2
+foo2 (long long a, int b, short c)
+{
+  return (st2){a, b, c};
+}
+
+st3
+foo3 (long long a, int b, short c, char d)
+{
+  return (st3){a, b, c, d};
+}
+
+st4
+foo4 (long long a, int b)
+{
+  return (st4){b, a};
+}
+
+st5
+foo5 (long long a, int b, short c)
+{
+  return (st5){c, b, a};
+}
+
+st6
+foo6 (long long a, int b, short c, char d)
+{
+  return (st6){d, c, b, a};
+}

